Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: hsqldb
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define hname hibernate-entitymanager

Summary:        Relational persistence and query service
Name:           hibernate3-entitymanager
Version:        3.2.0
Release:        alt2_0.cr1.0jpp5
Epoch:          0
License:        LGPL
URL:            http://annotations.hibernate.org/
Group:          Databases
Source0:        http://prdownloads.sourceforge.net/hibernate/hibernate-entitymanager-3.2.0.CR1.tar.gz
Source1:	hibernate-entitymanager-jdstyle.css
Patch1:		hibernate-entitymanager-build_xml.patch
Patch0:		hibernate-entitymanager-common-build_xml.patch
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant
BuildRequires: antlr
BuildRequires: asm
BuildRequires: cglib
BuildRequires: dom4j
BuildRequires: geronimo-jta-1.0.1B-api
BuildRequires: hibernate3 >= 0:3.2
BuildRequires: hibernate3-annotations >= 0:3.2
BuildRequires: hibernate3-ejb-persistence-3.0-api
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-logging
BuildRequires: javassist
BuildRequires: jboss4-common
#BuildRequires:  jboss-archive-browsing

Requires: hibernate3 >= 0:3.2
Requires: hibernate3-annotations >= 0:3.2
Requires: javassist
BuildArch:      noarch

%description
EJB3 standardizes the basic APIs and the metadata needed for
any object/relational persistence mechanism. Hibernate
EntityManager implements the programming interfaces,
lifecycle rules and packaging archive support as defined by
the EJB3 persistence specification.
Together with Hibernate Annotations, this wrapper implements
a complete (and standalone) EJB3 persistence provider, as
defined by the JSR-220 public final draft, on top of the
mature Hibernate3 core.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{hname}-%{version}.CR1
# remove all binary libs
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
mkdir test_output
cp %{SOURCE1} doc/api/jdstyle.css

%patch0 -b .sav
%patch1 -b .sav

%build
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
build-jar-repository -s -p . \
hibernate3

mkdir jdbc
build-jar-repository -s -p jdbc hsqldb

build-jar-repository -s -p lib \
antlr \
asm/asm \
cglib-nodep \
commons-collections \
commons-logging \
dom4j \
javassist \
jboss4/jboss-common \
jta \
hibernate3 \
hibernate3-annotations \
hibernate3-ejb-persistence-3.0-api

# hack!
rm lib/hibernate3-ejb-persistence-3.0-api.jar
mv lib/ejb3-persistence.jar.no lib/ejb3-persistence.jar

ant \
	-Dhibernate-core.home=. \
	-Djdk15.home=/usr/lib/jvm/java-1.5.0 \
	jar javadoc junitinstrument junit

%install

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{hname}/%{hname}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Mon Dec 08 2008 Igor Vlasenko <viy@altlinux.ru> 0:3.2.0-alt2_0.cr1.0jpp5
- hack: built with ejb-persistence-3.0-api-3.2.0 instead of 3.2.1

* Wed Jan 23 2008 Igor Vlasenko <viy@altlinux.ru> 0:3.2.0-alt1_0.cr1.2jpp5.0
- nobootstrap build

